import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 05.02.2007
  * @author
  */

public class GUI extends JFrame {
  // Anfang Attribute
  private Bankverwaltung meinVerwalter;
  // Anfang Variablen
  private JPanel jPlTitel = new JPanel(null);
  private JLabel jLblTitel = new JLabel();
  private JPanel jPlDaten = new JPanel(null);
    private JNumberField jNFKontonummer = new JNumberField();
    private JNumberField jNFPIN = new JNumberField();
    private JNumberField jNFKontostand = new JNumberField();
  private JLabel jLblInhaber = new JLabel();
  private JLabel jLblKontonummer = new JLabel();
  private JLabel jLblKontostand = new JLabel();
  private JTextField jTFInhaber = new JTextField();
  private JTextField jTFKontonummer = new JTextField();
  private JTextField jTFKontostand = new JTextField();
  private JButton jBtnOK = new JButton();
  private JButton jBtnEnde = new JButton();
  private JPasswordField jTFPIN = new JPasswordField();
  private JLabel jLblPIN = new JLabel();
  private JPanel jPlAktionen = new JPanel(null);
    private JNumberField jNFBetrag = new JNumberField();
    private JNumberField jNFEmpfaenger = new JNumberField();
  private JLabel jLbBetrag = new JLabel();
  private JLabel jLblEmpfaenger = new JLabel();
  private JTextField jTFBetrag = new JTextField();
  private JTextField jTFEmpfaenger = new JTextField();
  private JButton jBtnEinzahlen = new JButton();
  private JButton jBtnAbheben = new JButton();
  private JButton jBtnUeberweisen = new JButton();
  // Ende Attribute
  // Ende Variablen
  
  public GUI(String title) {
    // Frame-Initialisierung
    super(title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) { dispose(); }
    });
    int frameWidth = 453; 
    int frameHeight = 489;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2 ;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    
    jPlTitel.setBounds(8, 8, 425, 49);
    jPlTitel.setBackground(Color.GRAY);
    jPlTitel.setFont (new Font("Arial", Font.BOLD, 21));
    jPlTitel.setForeground(Color.RED);
    cp.add(jPlTitel);
    jLblTitel.setBounds(144, 16, 111, 24);
    jLblTitel.setText("Banksystem");
    jLblTitel.setFont(new Font("Dialog", Font.BOLD, 17));
    jLblTitel.setForeground(Color.BLACK);
    jPlTitel.add(jLblTitel);
    jPlDaten.setBounds(8, 72, 425, 161);
    cp.add(jPlDaten);
    jLblInhaber.setBounds(16, 24, 50, 20);
    jLblInhaber.setText("Inhaber:");
    jLblInhaber.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlDaten.add(jLblInhaber);
    jLblKontonummer.setBounds(16, 56, 89, 20);
    jLblKontonummer.setText("Kontonummer:");
    jLblKontonummer.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlDaten.add(jLblKontonummer);
    jLblKontostand.setBounds(16, 120, 74, 20);
    jLblKontostand.setText("Kontostand:");
    jLblKontostand.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlDaten.add(jLblKontostand);
    jTFInhaber.setBounds(112, 16, 121, 24);
    jTFInhaber.setEditable(false);
    jTFInhaber.setText("");
    jTFInhaber.setFont(new Font("Dialog", Font.PLAIN, 13));
    jTFInhaber.setForeground(new Color(0x333333));
    jTFInhaber.setEnabled(true);
    jPlDaten.add(jTFInhaber);
    jBtnOK.setBounds(280, 16, 105, 25);
    jBtnOK.setText("OK");
    jBtnOK.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlDaten.add(jBtnOK);
    jBtnOK.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtnOK_ActionPerformed(evt);
      }
    });
    
    jBtnEnde.setBounds(280, 48, 105, 25);
    jBtnEnde.setText("Ende");
    jBtnEnde.setVisible(false);
    jBtnEnde.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlDaten.add(jBtnEnde);
    jBtnEnde.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtnEnde_ActionPerformed(evt);
      }
    });
    
    jPlAktionen.setBounds(8, 280, 425, 137);
    cp.add(jPlAktionen);
    jLbBetrag.setBounds(16, 32, 46, 20);
    jLbBetrag.setText("Betrag:");
    jLbBetrag.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlAktionen.add(jLbBetrag);
    jLblEmpfaenger.setBounds(16, 72, 150, 20);
    jLblEmpfaenger.setText("Empfngerkontonummer:");
    jLblEmpfaenger.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlAktionen.add(jLblEmpfaenger);
    jBtnEinzahlen.setBounds(280, 24, 105, 25);
    jBtnEinzahlen.setText("Einzahlen");
    jBtnEinzahlen.setVisible(true);
    jBtnEinzahlen.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlAktionen.add(jBtnEinzahlen);
    jBtnEinzahlen.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtnEinzahlen_ActionPerformed(evt);
      }
    });
    
    jBtnAbheben.setBounds(280, 56, 105, 25);
    jBtnAbheben.setText("Abheben");
    jBtnAbheben.setVisible(false);
    jBtnAbheben.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlAktionen.add(jBtnAbheben);
    jBtnAbheben.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtnAbheben_ActionPerformed(evt);
      }
    });
    
    jBtnUeberweisen.setBounds(280, 96, 105, 25);
    jBtnUeberweisen.setText("berweisen");
    jBtnUeberweisen.setVisible(false);
    jBtnUeberweisen.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlAktionen.add(jBtnUeberweisen);
    jBtnUeberweisen.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBtnUeberweisen_ActionPerformed(evt);
      }
    });
    
    
    
    jLblPIN.setBounds(16, 88, 29, 20);
    jLblPIN.setText("PIN:");
    jLblPIN.setFont(new Font("Dialog", Font.PLAIN, 13));
    jPlDaten.add(jLblPIN);
    jNFKontonummer.setBounds(112, 48, 121, 25);
    jNFKontonummer.setText("");
    jPlDaten.add(jNFKontonummer);
    jNFPIN.setBounds(112, 80, 121, 25);
    jNFPIN.setText("");
    jPlDaten.add(jNFPIN);
    jNFKontostand.setBounds(112, 112, 123, 28);
    jNFKontostand.setText("");
    jNFKontostand.setEnabled(true);
    jNFKontostand.setForeground(new Color(0x333333));
    jNFKontostand.setBackground(Color.WHITE);
    jNFKontostand.setEditable(false);
    jPlDaten.add(jNFKontostand);
    jNFBetrag.setBounds(112, 40, 121, 25);
    jNFBetrag.setText("");
    jNFBetrag.setEnabled(true);
    jPlAktionen.add(jNFBetrag);
    jNFEmpfaenger.setBounds(112, 96, 121, 25);
    jNFEmpfaenger.setText("");
    jNFEmpfaenger.setEnabled(true);
    jNFEmpfaenger.setEditable(true);
    jPlAktionen.add(jNFEmpfaenger);
    setTitle("Banksystem");
    // Ende Komponenten
    
    setResizable(false);
    setVisible(true);
    meinVerwalter = new Bankverwaltung();
  }
  // Anfang Methoden
  
  // Anfang Ereignisprozeduren
  public void jBtnOK_ActionPerformed(ActionEvent evt) 
  {
    try {
      int pin = jNFPIN.getInt();
      int kontonummer = jNFKontonummer.getInt();
      meinVerwalter.anmelden(kontonummer, pin);
      jNFPIN.setText("");
      if (meinVerwalter.istAngemeldet()){
        jNFKontostand.setDouble(meinVerwalter.getSaldo());
        jTFInhaber.setText(meinVerwalter.getBesitzer());
        jBtnOK.setVisible(false);
        jBtnEinzahlen.setVisible(true);
        jBtnAbheben.setVisible(true);
        jBtnEnde.setVisible(true);
        
        jTFInhaber.setEditable(false);
        jTFKontonummer.setEditable(false);
        jTFPIN.setEditable(false);
        jTFBetrag.setEditable(true);
        jBtnUeberweisen.setVisible(true);
        jNFEmpfaenger.setEditable(true);
      }
      else {
        JOptionPane.showMessageDialog(null,"Kontonummer oder PIN falsch","Fehler",JOptionPane.WARNING_MESSAGE);
        jNFKontonummer.setText("");
      }
    }
    catch (NumberFormatException e){
      JOptionPane.showMessageDialog(null,"Eingabe enthlt falsche Zeichen oder ist leer","Fehler",JOptionPane.WARNING_MESSAGE);
      jNFKontonummer.setText("");
    }
  }
  
  
  public void jBtnEnde_ActionPerformed(ActionEvent evt) 
  {
    jBtnOK.setVisible(true);
    jBtnEinzahlen.setVisible(true);
    jBtnAbheben.setVisible(false);
    jBtnEnde.setVisible(false);
    jBtnUeberweisen.setVisible(false);
    
    jNFEmpfaenger.setEditable(false);
    jTFInhaber.setEditable(false);
    jNFKontonummer.setEditable(true);
    jNFPIN.setEditable(true);
    jNFBetrag.setEditable(true);
    
    jNFKontonummer.setText("");
    jTFInhaber.setText("");
    jNFKontostand.setText("");
    jNFPIN.setText("");
    jNFEmpfaenger.setText("");

  }
  
  public void jBtnEinzahlen_ActionPerformed(ActionEvent evt) 
  {
    try{
      double betrag = jNFBetrag.getDouble();
      if (!meinVerwalter.istAngemeldet())  {
        try {
          meinVerwalter.einzahlen(betrag, jNFEmpfaenger.getInt()); 
        }
        catch (NumberFormatException e) {
          JOptionPane.showMessageDialog(null,"Eingabe enthlt falsche Zeichen oder ist leer","Fehler",JOptionPane.WARNING_MESSAGE);
        }
      }
      else {
        try {
          int empfaenger = jNFEmpfaenger.getInt();
          meinVerwalter.einzahlen(betrag, empfaenger); 
        }
        catch(NumberFormatException e){
          meinVerwalter.einzahlen(betrag, jNFKontonummer.getInt()); 
        }
      }
    }
    catch (NumberFormatException e) {
      JOptionPane.showMessageDialog(null,"Eingabe enthlt falsche Zeichen oder ist leer","Fehler",JOptionPane.WARNING_MESSAGE);
    }
    jNFBetrag.setText("");
    jNFEmpfaenger.setText("");
  }
  
  public void jBtnAbheben_ActionPerformed(ActionEvent evt) 
  {
    try{
      meinVerwalter.abheben(jNFBetrag.getDouble());
    }
    catch (NumberFormatException e){
      JOptionPane.showMessageDialog(null,"Eingabe enthlt falsche Zeichen oder ist leer","Fehler", JOptionPane.WARNING_MESSAGE);
    }
    finally {
      jNFKontostand.setText(""+meinVerwalter.getSaldo());
      jNFBetrag.setText("");
    }
  }
  
  public void jBtnUeberweisen_ActionPerformed(ActionEvent evt) 
  {
    try {
      meinVerwalter.ueberweisen(jNFBetrag.getDouble(),jNFEmpfaenger.getInt());
    }
    catch (NumberFormatException e){
      JOptionPane.showMessageDialog(null,"Eingabe enthlt falsche Zeichen oder ist leer","Fehler",JOptionPane.WARNING_MESSAGE);
    }
    jNFKontostand.setText(""+meinVerwalter.getSaldo());
    jNFBetrag.setText("");
    jNFEmpfaenger.setText("");
  }
  
  
  
  // Ende Ereignisprozeduren
  public static void main(String[] args) 
  {
    new GUI("GUI");
  }
  // Ende Methoden
}