import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * Diese Klasse definiert eine Krabbe. Krabben leben auf dem Strand. Sie lieben
 * Sandwrmer (sehr lecker, vor allem die grnen).
 * 
 * Version: 2
 * 
 * In dieser Version bewegt sich die Krabbe mehr oder weniger nach dem Zufallsprinzip
 * ber den Strand.
 */

public class Crab extends Animal
{
    /** 
     *  Tut, was auch immer Krabben gerne tun. Diese Methode wird immer dann aufgerufen,
     *  wenn die Buttons 'Act' oder 'Run' in der Entwicklungsumgebung gedrckt werden.
     */
    public void act()
    {
        if ( atWorldEdge() ) 
        {
            turn(17);
        }

        if ( Greenfoot.getRandomNumber(100) < 10 ) 
        {
            turn( Greenfoot.getRandomNumber(90)-45 );
        }

        move();
    }
}